// rtf single word translaters

#include "rtfcoms.h"
#include "rtf2tad.h"
#include "environment.h"
#include "utfmap.h"
#include <vector>
#include <map>
#include <stdlib.h>
#include <mbstring.h>

extern vector<Environment> env;
extern vector<type_dword> col;
extern map<int,Font> fnt;
extern string late;
//extern bool tabChanged;

void fusen_fontattr()
{
  // wt : tHgwt
  cout.write("\xa2\xff\x04\x00\x00\x01",6);
  putbyte(Environment::current()->font_attr.bytes.hb);
  putbyte(Environment::current()->font_attr.bytes.lb);
}

void fusen_fontsize()
{
  // wt : TCYwt
  cout.write("\xa2\xff\x04\x00\x00\x02",6);
  putbyte(Environment::current()->font_size.bytes.hb);
  putbyte(Environment::current()->font_size.bytes.lb);
}

void fusen_alignment()
{
  // swt : swt
  cout.write("\xa1\xff\x02\x00",4);
  putbyte(Environment::current()->alignment);
  putbyte('\x01');
}

void fusen_txtcolor()
{
  // wt : J[wt
  cout.write("\xa2\xff\x06\x00\x00\x06",6);
  putbyte(Environment::current()->colorval.bytes.b1);
  putbyte(Environment::current()->colorval.bytes.b2);
  putbyte(Environment::current()->colorval.bytes.b3);
  putbyte(Environment::current()->colorval.bytes.b4);
}

void fusen_fonttype()
{
  // wt : tHgwt
  cout.write("\xa2\xff\x04\x00\x00\x00",6);
  putbyte(fnt[Environment::current()->nfont].font_type.bytes.hb);
  putbyte(fnt[Environment::current()->nfont].font_type.bytes.lb);
}

void fusen_decoration(unsigned char subid)
{
  // Cwt
  cout.write("\xa5\xff\x02\x00",4);
  putbyte(Environment::current()->pat_deco[subid]);
  putbyte(subid);
}

void fusen_soeji()
{
  // twt : Ywt
  cout.write("\xa4\xff",2);
  if (Environment::current()->is_soeji){
    cout.write("\x06\x00",2);
    putbyte(Environment::current()->pat_soeji);
    putbyte('\x04');
    if (Environment::current()->pat_soeji & 1 == 0){
      // t
      cout.write("\x00\x80",2);
    }
    else {
      // t
      cout.write("\x02\x01",2);
    }
    cout.write("\x02\x01",2);
  }
  else {
    cout.write("\x02\x00\x00\x05",4);
  }
}

void fusen_tabindent()
{
  // swt : ^uwt
  cout.write("\xa1\xff\x24\x00\x00\x02\x04\x01\x04\x01",10);
  // left,right,first-line
  putbyte(Environment::current()->ind_left.bytes.hb);
  putbyte(Environment::current()->ind_left.bytes.lb);
  putbyte(Environment::current()->ind_right.bytes.hb);
  putbyte(Environment::current()->ind_right.bytes.lb);
  putbyte(Environment::current()->ind_first.bytes.hb);
  putbyte(Environment::current()->ind_first.bytes.lb);
  
  cout.write("\x0b\x00\x48\x00\x90\x00\xd8\x00\x20\x01\x68\x01\xb0\x01\xf8\x01\x40\x02\x88\x02\xd0\x02\x18\x03",24);
}

void header()
{
  // (0)ǗZOg
  cout.write("\xe0\xff\x06\x00\x00\x00\x02\x00\x22\x01",10);
  // (1)͊JnZOg
  cout.write("\xe1\xff\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x88\xff\x88\xff\x21\x00\x00\x00",28);
  // (2)̓y[Wtwt : pwt
  cout.write("\xa0\xff\x0e\x00\x00\x00\x7b\x05\xe0\x03\x5e\x00\x46\x00\x6c\x00\x55\x00",18);
  // (3)̓y[Wtwt : }[Wwt
  cout.write("\xa0\xff\x0a\x00\x00\x01\x5e\x00\x76\x00\x6c\x00\x55\x00",14);
  // (4)̓y[Wtwt : pI[o[C`t
  cout.write("\xa0\xff\x22\x00\x00\x03\xa0\xff\x02\x00\x00\x08\xa1\xff\x04\x00\x00\x00\x00\x80\xa1\xff\x02\x00\x01\x01\x5d\x21\xad\xff\x04\x00\x00\x00\xc8\x00\x5d\x21",38);
  // (5)̓y[Wtwt : pI[o[Cwt
  cout.write("\xa0\xff\x04\x00\x00\x04\x00\x80",8);
  // (6)͊twt : s֑wt
  cout.write("\xa4\xff\x24\x00\x11\x08\x22\x21\x23\x21\x24\x21\x25\x21\x2b\x21\x2c\x21\x47\x21\x49\x21\x4b\x21\x4d\x21\x4f\x21\x51\x21\x53\x21\x55\x21\x57\x21\x59\x21\x5b\x21",40);
  // (7)͊twt : s֑wt
  cout.write("\xa4\xff\x18\x00\x11\x09\x46\x21\x48\x21\x4a\x21\x4c\x21\x4e\x21\x50\x21\x52\x21\x54\x21\x56\x21\x58\x21\x5a\x21",28);
  // (8)swt : ^uwt
  fusen_tabindent();
  // (10)swt : sԊuwt
  cout.write("\xa1\xff\x04\x00\x01\x00\x04\x01",8);
  // (9)wt : tHgwt
  fusen_fontattr();
  // wt : TCYwt
  fusen_fontsize();
  
  return;
}

void footer()
{
  // (22)͏IZOg
  cout.write("\xe2\xff\x00\x00",4);
  return;
}

void nop(string param)
{
  return;
}

void tag_par(string param)
{
  cout.write("\x0a\x00",2);
  return;
}

void tag_line(string param)
{
  cout.write("\x0d\x00",2);
  return;
}

void tag_page(string param)
{
  cout.write("\x0c\x00",2);
  return;
}

void tag_ldblquote(string param)
{
  Environment::current()->outputCurrentEnvironment();
  changeCharset(1);
  cout.write("\x48\x21",2);
}

void tag_rdblquote(string param)
{
  Environment::current()->outputCurrentEnvironment();
  changeCharset(1);
  cout.write("\x49\x21",2);
}

void tag_lquote(string param)
{
  Environment::current()->outputCurrentEnvironment();
  changeCharset(1);
  cout.write("\x46\x21",2);
}

void tag_rquote(string param)
{
  Environment::current()->outputCurrentEnvironment();
  changeCharset(1);
  cout.write("\x47\x21",2);
}

void tag_endash(string param)
{
  Environment::current()->outputCurrentEnvironment();
  changeCharset(1);
  cout.write("\x7c\x23",2);
}

void tag_emdash(string param)
{
  Environment::current()->outputCurrentEnvironment();
  changeCharset(1);
  cout.write("\x3d\x21",2);
}

void tag_bold(string param)
{
  if (param == "0"){
    (*env.rbegin()).font_attr.uw &= ~0x0028;
  }
  else {
    (*env.rbegin()).font_attr.uw |= 0x0028;
  }
  return;
}

void tag_italic(string param)
{
  if (param == "0"){
    (*env.rbegin()).font_attr.uw &= ~0x0040;
  }
  else {
    (*env.rbegin()).font_attr.uw |= 0x0040;
  }
  return;
}

void tag_fontsize(string param)
{
  int size = atoi(param.c_str());
  unsigned short uw = 0x8000U + unsigned(10*size);
  
  if (size > 0){
    (*env.rbegin()).font_size.uw = uw;
  }
  return;
}

void tag_tab(string param)
{
  cout.write("\x09\x00",2);
}

void tag_ralign(string param)
{
  (*env.rbegin()).alignment = 2;
}

void tag_lalign(string param)
{
  (*env.rbegin()).alignment = 0;
}

void tag_calign(string param)
{
  (*env.rbegin()).alignment = 1;
}

void tag_pard(string param)
{
  if ((*env.rbegin()).alignment != 0){
    tag_lalign(param);
  }
  // ȉCfgWɒAӏŃguôŃRgAEg
  /*if ((*env.rbegin()).ind_left.w != 0
      || (*env.rbegin()).ind_first.w != 0
      || (*env.rbegin()).ind_right.w != 0 ){
    (*env.rbegin()).ind_left.w = (*env.rbegin()).ind_first.w
      = (*env.rbegin()).ind_right.w = 0;
    fusen_tabindent();
  }*/
  // Ԃ񑼂̏KvBɕtĂB
}

void tag_colortbl(string param)
{
  // \colortbl̒g(\red,\green,\blue)܂߂ď
  char ch;
  string com;
  int i = 1, j;
  type_dword ctmp;
  unsigned char r = 0, g = 0, b = 0;
  col.clear();
  
  while (i > 0){
    ch = getchar();
    switch (ch){
    case ';':
      // F̓o^
      ctmp.bytes.b1 = b;
      ctmp.bytes.b2 = g;
      ctmp.bytes.b3 = r;
      ctmp.bytes.b4 = 0x10;
      col.push_back(ctmp);
      r = g = b = 0;
      break;
    case '\\':
      // \red,\green,\bluȅ
      get_command(&com,&param);
      // F̒lƂ
      j = atoi(param.c_str());
      if (com == "green")
        g = j;
      else if (com == "red")
        r = j;
      else if (com == "blue")
        b = j;
      break;
    case '{':
      i++;
      break;
    case '}':
      i--;
      break;
    }
  };
  env.pop_back();
}

void tag_color(string param)
{
  int n = atoi(param.c_str());
  (*env.rbegin()).colorval = col[n];
}

void tag_fonttbl(string param)
{
  // \fonttbl̒g(\f,\fcharset,\froman,...)܂߂ď
  int i = 1, j = 0;
  char ch;
  Font fnttmp;
  string com;
  
  while (i > 0){
    ch = getbyte();
    switch (ch){
    case '\\':
      getbyte();
      break;
    case '{':
      i++;
      break;
    case '}':
      i--;
      break;
    }
    while (i >= 2){
      // \fonttbl{...}{...}...̓(font͓ǂݍނA͂Ȃ)
      ch = getbyte();
      switch (ch){
      case '\\':
        get_command(&com,&param);
        if (com == "f"){
          j = atoi(param.c_str());
          fnt.insert(pair<int,Font>(j,fnttmp));
        }
        else if (com == "froman"){
          fnt[j].font_type.uw = 0x60c6;
        }
        else if (com == "fmodern" || com == "fswiss" || com == "fnil"){
          fnt[j].font_type.uw = 0x00c0;
        }
        else if (com == "fcharset"){
          fnt[j].charset = atoi(param.c_str());
        }
        else if (com.empty()){
          getbyte();
        }
        break;
      case '{':
        i++;
        break;
      case '}':
        i--;
        break;
      }
    }
  }
  env.pop_back();
}

void tag_font(string param)
{
  map<int,Font>::iterator itr = fnt.find(atoi(param.c_str()));
  if (itr != fnt.end()){
    (*env.rbegin()).nfont = itr->first;
  }
}

void tag_underline(string param)
{
  unsigned char subid = 0; // underline
  if (param == "0"){
    (*env.rbegin()).is_deco[subid] = false;
  }
  else {
    (*env.rbegin()).is_deco[subid] = true;
    (*env.rbegin()).pat_deco[subid] = '\x20';
  }
}

void tag_no_underline(string param)
{
  tag_underline("0");
}

void tag_shading(string param)
{
  unsigned char subid = 14; // shading
  int density = atoi(param.c_str());
  if (density <= 0 || density > 10000){
    (*env.rbegin()).is_deco[subid] = false;
  }
  else {
    (*env.rbegin()).is_deco[subid] = true;
    if (density < 1000){
      (*env.rbegin()).pat_deco[subid] = '\x10';
    }
    else if (density < 2000){
      (*env.rbegin()).pat_deco[subid] = '\x20';
    }
    else {
      (*env.rbegin()).pat_deco[subid] = '\x30';
    }
  }
}

void tag_shadow(string param)
{
  if (param == "0"){
    (*env.rbegin()).font_attr.uw &= ~0x0400;
  }
  else {
    (*env.rbegin()).font_attr.uw |= 0x0400;
  }
  return;
}

void tag_outline(string param)
{
  if (param == "0"){
    (*env.rbegin()).font_attr.uw &= ~0x0200;
  }
  else {
    (*env.rbegin()).font_attr.uw |= 0x0200;
  }
  return;
}

void tag_super(string param)
{
  if (param == "0"){
    (*env.rbegin()).is_soeji = false;
  }
  else {
    (*env.rbegin()).is_soeji = true;
    (*env.rbegin()).pat_soeji = '\x81';
  }
}

void tag_sub(string param)
{
  if (param == "0"){
    (*env.rbegin()).is_soeji = false;
  }
  else {
    (*env.rbegin()).is_soeji = true;
    (*env.rbegin()).pat_soeji = '\x80';
  }
}

void tag_soejioff(string param)
{
  tag_super("0");
}

string voidtag()
{
  string ret;
  int i = 1;
  char ch;
  
  while (i > 0) {
    ch = getbyte();
    
    if (ch == '\\'){
      ret += ch;
      ch = getbyte();
    }
    else if (ch == '{'){
      i++;
    }
    else if (ch == '}'){
      i--;
    }
    else if (_ismbblead(ch)){
      ret += ch;
      ch = getbyte();
    }
    ret += ch;
  }
  env.pop_back();
  return ret;
}

void tag_invalid(string param)
{
  voidtag();
}

void tag_plain(string param)
{
  Environment defenv;
  int i;
  if (defenv.font_attr.uw != (*env.rbegin()).font_attr.uw){
    (*env.rbegin()).font_attr.uw = defenv.font_attr.uw;
  }
  if (defenv.font_size.uw != (*env.rbegin()).font_size.uw){
    (*env.rbegin()).font_size.uw = defenv.font_size.uw;
  }
  if (defenv.colorval.ul != (*env.rbegin()).colorval.ul){
    (*env.rbegin()).colorval.ul = defenv.colorval.ul;
  }
  if (defenv.is_soeji != (*env.rbegin()).is_soeji){
    (*env.rbegin()).is_soeji = defenv.is_soeji;
  }
  for (i=0;i<256;i++){
    if ((*env.rbegin()).is_deco[i]){
      (*env.rbegin()).is_deco[i] = false;
    }
  }
  // ɕtĂ
}

// unitsff88hłƉ(͊JnZOgŎw肳Ă)
// 1/120inch P(tad) <- 1/(72*20)inchP(rtf;͐)
void tag_leftindent(string param)
{
  (*env.rbegin()).ind_left.w = atoi(param.c_str()) * 120 / 1440;
}

void tag_firstindent(string param)
{
  (*env.rbegin()).ind_first.w = atoi(param.c_str()) * 120 / 1440;
}

void tag_rightindent(string param)
{
  (*env.rbegin()).ind_right.w = atoi(param.c_str()) * 120 / 1440;
}

// []xKv(Ƃ\fi,\li邱Ƃ)
void tag_pntext(string param)
{
  late += "{" + voidtag();
  // Ƃ̓eLXgoĂɂɏOK
}

// Unicode Related
void tag_uni_ignorebytes(string param)
{
  int n = atoi(param.c_str());
  (*env.rbegin()).unicode_ignore = n;
}

void tag_unichar(string param)
{
  unsigned long int ch = 0;
  unsigned short n = atoi(param.c_str());
  if (n >= 0x4e00U && n <= 0x9fa5U){
    ch = tbl_utf2tc_a[n-0x4e00U];
  }
  else if (n >= 0xf900U && n <= 0xfa2dU){
    ch = tbl_utf2tc_b[n-0xf900U];
  }
  if (ch != 0){
    Environment::current()->outputCurrentEnvironment();
    changeCharset((ch >> 16) - 0x20U);
    putbyte(ch & 0x00ff);
    putbyte((ch & 0xff00) >> 8);
    for (int i = (*env.rbegin()).unicode_ignore; i > 0; i--){
      char ch = getbyte();
      if (ch == '\\'){
        ch = peekbyte();
        if (ch == '\''){
          for (int j = 0; j < 3; j++){
            getbyte();
          }
        }
        else {
          cerr << "Unicode֕słB" << endl;
        }
      }
    }
  }
}

